import QtQuick 2.12
import QtQuick.Controls 2.5
import QtQuick.Layouts 1.3
import "Controller.js" as Controller
import IconTheme 1.0
import QtGraphicalEffects 1.0
// import org.kylin.qqc2style.private 1.0 as StylePrivate

Rectangle {
    id : closeButton

    property var closeButtonController : new Controller.CloseButtonController(multitaskViewModel, closeButton, multitaskViewManager, ["app"])
    property var buttonStateList : ["default", "hover", "click"];
    state : "default"
    property var closeButtonColor : closeButtonDefaultColor
    property int wid : -1
    property alias closeButtonContainMouse: closeButtonMouseArea.containsMouse

    visible : closeButtonVisble
    width : 24
    height : 24
    radius : 14
    color : closeButtonColor

    IconTheme {
        anchors.centerIn : parent
        width : 12
        height : 12
        iconName : "window-close-symbolic"
    }

    function setStatus(status) {
        if(buttonStateList.indexOf(status) < 0)
        {
            return;
        }
        if (status === state) {
            return
        } else {
            state = status;
        }
    }

    function setDefaultStatus() {

        setStatus("default")
    }

    function setHoverStatus() {

        setStatus("hover")
    }

    function setClickStatus() {

        setStatus("click")
    }

    function setId(wId) {
        wid = wId;
    }

    MouseArea{
        id : closeButtonMouseArea
        anchors.fill : parent
        hoverEnabled : true

        onEntered: {
            closeButtonController.setHoverStatus()
        }

        onExited: {
            closeButtonController.setDefaultStatus()
            if(!previewMouseArea.containsMouse)
            {
                previewWindow.setDefaultStatus()
            }
        }

        onClicked: {
            closeButtonController.setClickStatus()
            controller.removePreviewWindow(wid);
        }
    }
}
